Index: /trunk/Delphes.cpp
===================================================================
--- /trunk/Delphes.cpp	(revision 66)
+++ /trunk/Delphes.cpp	(revision 67)
@@ -30,4 +30,5 @@
 #include "interface/JetUtils.h"
 
+#include "Utilities/FROG/Examples/Sim_Delphes/FrogUtil.h"
 
 #include <vector>
@@ -353,10 +354,9 @@
   delete treeWriter;
 
-/*  if(DET->DOTRIGGER == 1) 
+  if(DET->DOTRIGGER == 1) 
     {
-//      TChain chainT("Analysis");
-//      chainT.Add(outputfilename.c_str());
-      ExRootTreeReader *treeReaderT = new ExRootTreeReader("Analysis");
-
+      TChain chainT("Analysis");
+      chainT.Add(outputfilename.c_str());
+      ExRootTreeReader *treeReaderT = new ExRootTreeReader(&chainT);
 
       const TClonesArray *branchElecTrig = treeReaderT->UseBranch("Electron");
@@ -366,14 +366,24 @@
       const TClonesArray *branchPhotonTrig = treeReaderT->UseBranch("Photon");
       const TClonesArray *branchETmisTrig = treeReaderT->UseBranch("ETmis");
-   
-     // Loop over all events
+  
+      ExRootTreeWriter *treeWriterT = new ExRootTreeWriter(outputfilename, "Trigger");
+      ExRootTreeBranch *branchTrigger = treeWriterT->NewBranch("Trigger", TRootTrigger::Class());
+
+      TRootTrigger *elementTrigger;
+
      Long64_t entryT, allEntriesT = treeReaderT->GetEntries();
-      cout << "** Chain contains " << allEntriesT << " events" << endl;
+     cout << "** Chain contains " << allEntriesT << " events" << endl;
      for(entryT = 0; entryT < allEntriesT; ++entryT)
         {
-//cout<<"entry "<<entryT<<endl;
+          treeWriterT->Clear();
+//          treeReaderT->ReadEntry(entry);
+          elementTrigger = (TRootTrigger*) branchTrigger->NewEntry();
+          elementTrigger->Accepted=true;
+          treeWriterT->Fill();
         }
+
+    treeWriterT->Write();
+    delete treeWriterT;
    }
-*/
 
   cout << "** Exiting..." << endl;
Index: /trunk/Utilities/ExRootAnalysis/interface/BlockClasses.h
===================================================================
--- /trunk/Utilities/ExRootAnalysis/interface/BlockClasses.h	(revision 66)
+++ /trunk/Utilities/ExRootAnalysis/interface/BlockClasses.h	(revision 67)
@@ -13,6 +13,6 @@
  *  present in the data members of the Block TRoot class.
  *
- *  $Date: 2008-11-27 18:26:42 $
- *  $Revision: 1.3 $
+ *  $Date: 2008-12-02 11:14:45 $
+ *  $Revision: 1.4 $
  *
  *  
@@ -289,4 +289,18 @@
 //---------------------------------------------------------------------------
 
+class TRootTrigger: public TSortableObject
+{
+public:
+  TRootTrigger() {};
+    static TCompare *fgCompare; //!
+
+  bool Accepted;
+  bool GlobalAccepted;
+
+  ClassDef(TRootTrigger, 1)
+
+};
+//---------------------------------------------------------------------------
+
 class TRootETmis: public TSortableObject
 {
Index: /trunk/Utilities/ExRootAnalysis/src/BlockClasses.cc
===================================================================
--- /trunk/Utilities/ExRootAnalysis/src/BlockClasses.cc	(revision 66)
+++ /trunk/Utilities/ExRootAnalysis/src/BlockClasses.cc	(revision 67)
@@ -11,6 +11,6 @@
  *  to preserve mother-dautherlinks between particles.
  *
- *  $Date: 2008-11-04 10:32:26 $
- *  $Revision: 1.1 $
+ *  $Date: 2008-12-02 11:14:45 $
+ *  $Revision: 1.2 $
  *
  *  
@@ -36,4 +36,5 @@
 TCompare *TRootLHEFParticle::fgCompare = 0;
 TCompare *TRootRomanPotHits::fgCompare =0;
+TCompare *TRootTrigger::fgCompare =0;
 
 void TRootParticle::Set(const TLorentzVector& momentum) {
Index: /trunk/Utilities/ExRootAnalysis/src/BlockClassesLinkDef.h
===================================================================
--- /trunk/Utilities/ExRootAnalysis/src/BlockClassesLinkDef.h	(revision 66)
+++ /trunk/Utilities/ExRootAnalysis/src/BlockClassesLinkDef.h	(revision 67)
@@ -4,6 +4,6 @@
  *  Lists classes to be included in cint dicitonary
  *
- *  $Date: 2008-11-04 10:32:26 $
- *  $Revision: 1.1 $
+ *  $Date: 2008-12-02 11:14:45 $
+ *  $Revision: 1.2 $
  *
  *  
@@ -34,4 +34,5 @@
 #pragma link C++ class TRootZdcHits;
 #pragma link C++ class TRootRomanPotHits;
+#pragma link C++ class TRootTrigger;
 
 #pragma link C++ class TRootParticle;