Index: display/Delphes3DGeometry.cc
===================================================================
--- display/Delphes3DGeometry.cc	(revision 341014c3f3bd3259d845de52bde54ba6c3b4ed08)
+++ display/Delphes3DGeometry.cc	(revision 69da13658a128f4ae9244ffdc4f999fa20434989)
@@ -173,5 +173,5 @@
   for(std::vector<std::string>::const_iterator calo = calorimeters_.begin(); calo != calorimeters_.end(); ++calo)
   {
-    set<pair<Double_t, Int_t>> caloBinning;
+    set<pair<Double_t, Int_t> > caloBinning;
     ExRootConfParam paramEtaBins, paramPhiBins;
     ExRootConfParam param = confReader->GetParam(Form("%s::EtaPhiBins", calo->c_str()));
@@ -187,8 +187,8 @@
   }
 
-  set<pair<Double_t, Int_t>> caloBinning = caloBinning_[*calorimeters_.begin()];
+  set<pair<Double_t, Int_t> > caloBinning = caloBinning_[*calorimeters_.begin()];
   Double_t *etaBins = new Double_t[caloBinning.size()]; // note that this is the eta binning of the first calo
   unsigned int ii = 0;
-  for(set<pair<Double_t, Int_t>>::const_iterator itEtaSet = caloBinning.begin(); itEtaSet != caloBinning.end(); ++itEtaSet)
+  for(set<pair<Double_t, Int_t> >::const_iterator itEtaSet = caloBinning.begin(); itEtaSet != caloBinning.end(); ++itEtaSet)
   {
     etaBins[ii++] = itEtaSet->first;
@@ -252,5 +252,5 @@
 
 std::pair<Double_t, Double_t> Delphes3DGeometry::addCalorimeter(TGeoVolume *top, const char *name,
-  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t>> &caloBinning)
+  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t> > &caloBinning)
 {
   // parameters derived from the inputs
@@ -316,5 +316,5 @@
 
 void Delphes3DGeometry::addCaloTowers(TGeoVolume *top, const char *name,
-  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t>> &caloBinning)
+  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t> > &caloBinning)
 {
 
@@ -339,5 +339,5 @@
   Int_t etaslice = 0;
   std::map<std::pair<int, int>, TGeoRotation *> phirotations;
-  for(set<pair<Double_t, Int_t>>::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
+  for(set<pair<Double_t, Int_t> >::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
   {
     if(abs(bin->first) > calo_endcap_etamin) continue; // only in the barrel
@@ -388,5 +388,5 @@
   etaslice = 0;
   phirotations.clear();
-  for(set<pair<Double_t, Int_t>>::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
+  for(set<pair<Double_t, Int_t> >::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
   {
     if(bin->first < calo_endcap_etamin) continue; // only in the + endcap
Index: display/Delphes3DGeometry.h
===================================================================
--- display/Delphes3DGeometry.h	(revision 341014c3f3bd3259d845de52bde54ba6c3b4ed08)
+++ display/Delphes3DGeometry.h	(revision 69da13658a128f4ae9244ffdc4f999fa20434989)
@@ -60,7 +60,7 @@
 private:
   std::pair<Double_t, Double_t> addTracker(TGeoVolume *top);
-  std::pair<Double_t, Double_t> addCalorimeter(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t>> &caloBinning);
+  std::pair<Double_t, Double_t> addCalorimeter(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t> > &caloBinning);
   std::pair<Double_t, Double_t> addMuonDets(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength);
-  void addCaloTowers(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t>> &caloBinning);
+  void addCaloTowers(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t> > &caloBinning);
 
 private:
@@ -90,5 +90,5 @@
 
   std::map<std::string, Double_t> muonSystem_etamax_;
-  std::map<std::string, std::set<std::pair<Double_t, Int_t>>> caloBinning_;
+  std::map<std::string, std::set<std::pair<Double_t, Int_t> > > caloBinning_;
 };
 
Index: display/DelphesPlotSummary.cc
===================================================================
--- display/DelphesPlotSummary.cc	(revision 341014c3f3bd3259d845de52bde54ba6c3b4ed08)
+++ display/DelphesPlotSummary.cc	(revision 69da13658a128f4ae9244ffdc4f999fa20434989)
@@ -181,5 +181,5 @@
 {
   // clear event histograms and markers
-  for(std::map<TString, std::vector<TH1F *>>::iterator hv = eventProfiles_.begin(); hv != eventProfiles_.end(); ++hv)
+  for(std::map<TString, std::vector<TH1F *> >::iterator hv = eventProfiles_.begin(); hv != eventProfiles_.end(); ++hv)
   {
     for(std::vector<TH1F *>::iterator h = hv->second.begin(); h < hv->second.end(); ++h)
@@ -188,5 +188,5 @@
     }
   }
-  for(std::map<TString, std::vector<TMarker *>>::iterator mv = eventMarkers_.begin(); mv != eventMarkers_.end(); ++mv)
+  for(std::map<TString, std::vector<TMarker *> >::iterator mv = eventMarkers_.begin(); mv != eventMarkers_.end(); ++mv)
   {
     for(std::vector<TMarker *>::iterator m = mv->second.begin(); m < mv->second.end(); ++m)
Index: display/DelphesPlotSummary.h
===================================================================
--- display/DelphesPlotSummary.h	(revision 341014c3f3bd3259d845de52bde54ba6c3b4ed08)
+++ display/DelphesPlotSummary.h	(revision 69da13658a128f4ae9244ffdc4f999fa20434989)
@@ -45,8 +45,8 @@
   TEveWindowTab *tab_;
   std::map<TString, TCanvas *> canvases_;
-  std::map<TString, std::vector<TH1F *>> histograms_;
+  std::map<TString, std::vector<TH1F *> > histograms_;
   std::vector<DelphesBranchBase *> *elements_;
-  std::map<TString, std::vector<TMarker *>> eventMarkers_;
-  std::map<TString, std::vector<TH1F *>> eventProfiles_;
+  std::map<TString, std::vector<TMarker *> > eventMarkers_;
+  std::map<TString, std::vector<TH1F *> > eventProfiles_;
 };
 