Index: .clang-format
===================================================================
--- .clang-format	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ .clang-format	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -1,4 +1,5 @@
 BasedOnStyle: LLVM
 Language: Cpp
+Standard: Cpp03
 IndentWidth: 2
 ConstructorInitializerIndentWidth: 2
Index: classes/DelphesClasses.h
===================================================================
--- classes/DelphesClasses.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ classes/DelphesClasses.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -614,5 +614,5 @@
 
   Int_t NTimeHits;
-  std::vector<std::pair<Float_t, Float_t>> ECalEnergyTimePairs;
+  std::vector<std::pair<Float_t, Float_t> > ECalEnergyTimePairs;
 
   // Isolation variables
Index: classes/DelphesHepMCReader.cc
===================================================================
--- classes/DelphesHepMCReader.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ classes/DelphesHepMCReader.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -110,6 +110,6 @@
   TObjArray *partonOutputArray)
 {
-  map<int, pair<int, int>>::iterator itMotherMap;
-  map<int, pair<int, int>>::iterator itDaughterMap;
+  map<int, pair<int, int> >::iterator itMotherMap;
+  map<int, pair<int, int> >::iterator itDaughterMap;
   char key, momentumUnit[4], positionUnit[3];
   int i, rc, state;
@@ -433,6 +433,6 @@
 {
   Candidate *candidate;
-  map<int, pair<int, int>>::iterator itMotherMap;
-  map<int, pair<int, int>>::iterator itDaughterMap;
+  map<int, pair<int, int> >::iterator itMotherMap;
+  map<int, pair<int, int> >::iterator itDaughterMap;
   int i;
 
Index: classes/DelphesHepMCReader.h
===================================================================
--- classes/DelphesHepMCReader.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ classes/DelphesHepMCReader.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -98,6 +98,6 @@
   int fParticleCounter;
 
-  std::map<int, std::pair<int, int>> fMotherMap;
-  std::map<int, std::pair<int, int>> fDaughterMap;
+  std::map<int, std::pair<int, int> > fMotherMap;
+  std::map<int, std::pair<int, int> > fDaughterMap;
 };
 
Index: classes/DelphesLHEFReader.cc
===================================================================
--- classes/DelphesLHEFReader.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ classes/DelphesLHEFReader.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -256,5 +256,5 @@
 {
   LHEFWeight *element;
-  vector<pair<int, double>>::const_iterator itWeightList;
+  vector<pair<int, double> >::const_iterator itWeightList;
 
   for(itWeightList = fWeightList.begin(); itWeightList != fWeightList.end(); ++itWeightList)
Index: classes/DelphesLHEFReader.h
===================================================================
--- classes/DelphesLHEFReader.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ classes/DelphesLHEFReader.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -82,5 +82,5 @@
   double fPx, fPy, fPz, fE, fMass;
 
-  std::vector<std::pair<int, double>> fWeightList;
+  std::vector<std::pair<int, double> > fWeightList;
 };
 
Index: display/Delphes3DGeometry.cc
===================================================================
--- display/Delphes3DGeometry.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ display/Delphes3DGeometry.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -173,5 +173,5 @@
   for(std::vector<std::string>::const_iterator calo = calorimeters_.begin(); calo != calorimeters_.end(); ++calo)
   {
-    set<pair<Double_t, Int_t>> caloBinning;
+    set<pair<Double_t, Int_t> > caloBinning;
     ExRootConfParam paramEtaBins, paramPhiBins;
     ExRootConfParam param = confReader->GetParam(Form("%s::EtaPhiBins", calo->c_str()));
@@ -187,8 +187,8 @@
   }
 
-  set<pair<Double_t, Int_t>> caloBinning = caloBinning_[*calorimeters_.begin()];
+  set<pair<Double_t, Int_t> > caloBinning = caloBinning_[*calorimeters_.begin()];
   Double_t *etaBins = new Double_t[caloBinning.size()]; // note that this is the eta binning of the first calo
   unsigned int ii = 0;
-  for(set<pair<Double_t, Int_t>>::const_iterator itEtaSet = caloBinning.begin(); itEtaSet != caloBinning.end(); ++itEtaSet)
+  for(set<pair<Double_t, Int_t> >::const_iterator itEtaSet = caloBinning.begin(); itEtaSet != caloBinning.end(); ++itEtaSet)
   {
     etaBins[ii++] = itEtaSet->first;
@@ -252,5 +252,5 @@
 
 std::pair<Double_t, Double_t> Delphes3DGeometry::addCalorimeter(TGeoVolume *top, const char *name,
-  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t>> &caloBinning)
+  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t> > &caloBinning)
 {
   // parameters derived from the inputs
@@ -316,5 +316,5 @@
 
 void Delphes3DGeometry::addCaloTowers(TGeoVolume *top, const char *name,
-  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t>> &caloBinning)
+  Double_t innerBarrelRadius, Double_t innerBarrelLength, set<pair<Double_t, Int_t> > &caloBinning)
 {
 
@@ -339,5 +339,5 @@
   Int_t etaslice = 0;
   std::map<std::pair<int, int>, TGeoRotation *> phirotations;
-  for(set<pair<Double_t, Int_t>>::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
+  for(set<pair<Double_t, Int_t> >::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
   {
     if(abs(bin->first) > calo_endcap_etamin) continue; // only in the barrel
@@ -388,5 +388,5 @@
   etaslice = 0;
   phirotations.clear();
-  for(set<pair<Double_t, Int_t>>::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
+  for(set<pair<Double_t, Int_t> >::const_iterator bin = caloBinning.begin(); bin != caloBinning.end(); ++bin)
   {
     if(bin->first < calo_endcap_etamin) continue; // only in the + endcap
Index: display/Delphes3DGeometry.h
===================================================================
--- display/Delphes3DGeometry.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ display/Delphes3DGeometry.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -60,7 +60,7 @@
 private:
   std::pair<Double_t, Double_t> addTracker(TGeoVolume *top);
-  std::pair<Double_t, Double_t> addCalorimeter(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t>> &caloBinning);
+  std::pair<Double_t, Double_t> addCalorimeter(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t> > &caloBinning);
   std::pair<Double_t, Double_t> addMuonDets(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength);
-  void addCaloTowers(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t>> &caloBinning);
+  void addCaloTowers(TGeoVolume *top, const char *name, Double_t innerBarrelRadius, Double_t innerBarrelLength, std::set<std::pair<Double_t, Int_t> > &caloBinning);
 
 private:
@@ -90,5 +90,5 @@
 
   std::map<std::string, Double_t> muonSystem_etamax_;
-  std::map<std::string, std::set<std::pair<Double_t, Int_t>>> caloBinning_;
+  std::map<std::string, std::set<std::pair<Double_t, Int_t> > > caloBinning_;
 };
 
Index: display/DelphesPlotSummary.cc
===================================================================
--- display/DelphesPlotSummary.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ display/DelphesPlotSummary.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -181,5 +181,5 @@
 {
   // clear event histograms and markers
-  for(std::map<TString, std::vector<TH1F *>>::iterator hv = eventProfiles_.begin(); hv != eventProfiles_.end(); ++hv)
+  for(std::map<TString, std::vector<TH1F *> >::iterator hv = eventProfiles_.begin(); hv != eventProfiles_.end(); ++hv)
   {
     for(std::vector<TH1F *>::iterator h = hv->second.begin(); h < hv->second.end(); ++h)
@@ -188,5 +188,5 @@
     }
   }
-  for(std::map<TString, std::vector<TMarker *>>::iterator mv = eventMarkers_.begin(); mv != eventMarkers_.end(); ++mv)
+  for(std::map<TString, std::vector<TMarker *> >::iterator mv = eventMarkers_.begin(); mv != eventMarkers_.end(); ++mv)
   {
     for(std::vector<TMarker *>::iterator m = mv->second.begin(); m < mv->second.end(); ++m)
Index: display/DelphesPlotSummary.h
===================================================================
--- display/DelphesPlotSummary.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ display/DelphesPlotSummary.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -45,8 +45,8 @@
   TEveWindowTab *tab_;
   std::map<TString, TCanvas *> canvases_;
-  std::map<TString, std::vector<TH1F *>> histograms_;
+  std::map<TString, std::vector<TH1F *> > histograms_;
   std::vector<DelphesBranchBase *> *elements_;
-  std::map<TString, std::vector<TMarker *>> eventMarkers_;
-  std::map<TString, std::vector<TH1F *>> eventProfiles_;
+  std::map<TString, std::vector<TMarker *> > eventMarkers_;
+  std::map<TString, std::vector<TH1F *> > eventProfiles_;
 };
 
Index: examples/CaloGrid.cpp
===================================================================
--- examples/CaloGrid.cpp	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ examples/CaloGrid.cpp	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -41,5 +41,5 @@
 
   std::vector<std::string> calorimeters_;
-  std::map<std::string, std::set<std::pair<Double_t, Int_t>>> caloBinning_;
+  std::map<std::string, std::set<std::pair<Double_t, Int_t> > > caloBinning_;
 
   std::string s(argv[2]);
@@ -90,5 +90,5 @@
 
     //first entry is eta bin, second is number of phi bins
-    set<pair<Double_t, Int_t>> caloBinning;
+    set<pair<Double_t, Int_t> > caloBinning;
     ExRootConfParam paramEtaBins, paramPhiBins;
     ExRootConfParam param = confReader->GetParam(Form("%s::EtaPhiBins", calo->c_str()));
@@ -109,5 +109,5 @@
 
     //loop over calo binning
-    std::set<std::pair<Double_t, Int_t>>::iterator it;
+    std::set<std::pair<Double_t, Int_t> >::iterator it;
 
     Int_t n = -1;
@@ -122,5 +122,5 @@
       liney->Draw();
 
-      set<std::pair<Double_t, Int_t>>::iterator it2 = it;
+      set<std::pair<Double_t, Int_t> >::iterator it2 = it;
       it2--;
 
Index: external/ExRootAnalysis/ExRootFilter.cc
===================================================================
--- external/ExRootAnalysis/ExRootFilter.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ external/ExRootAnalysis/ExRootFilter.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -21,5 +21,5 @@
 
 typedef map<Int_t, TObjArray *> TCategoryMap;
-typedef map<ExRootClassifier *, pair<Bool_t, TCategoryMap>> TClassifierMap;
+typedef map<ExRootClassifier *, pair<Bool_t, TCategoryMap> > TClassifierMap;
 
 ExRootFilter::ExRootFilter(const TSeqCollection *collection) :
Index: external/ExRootAnalysis/ExRootFilter.h
===================================================================
--- external/ExRootAnalysis/ExRootFilter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ external/ExRootAnalysis/ExRootFilter.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -25,5 +25,5 @@
   TIterator *fIter; //!
 
-  std::map<ExRootClassifier *, std::pair<Bool_t, std::map<Int_t, TObjArray *>>> fMap; //!
+  std::map<ExRootClassifier *, std::pair<Bool_t, std::map<Int_t, TObjArray *> > > fMap; //!
 };
 
Index: external/ExRootAnalysis/ExRootTreeReader.h
===================================================================
--- external/ExRootAnalysis/ExRootTreeReader.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ external/ExRootAnalysis/ExRootTreeReader.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -36,5 +36,5 @@
   Int_t fCurrentTree; //! current Tree number in a TChain
 
-  typedef std::map<TString, std::pair<TBranch *, TClonesArray *>> TBranchMap;
+  typedef std::map<TString, std::pair<TBranch *, TClonesArray *> > TBranchMap;
 
   TBranchMap fBranchMap; //!
Index: modules/Calorimeter.h
===================================================================
--- modules/Calorimeter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/Calorimeter.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -50,6 +50,6 @@
 
 private:
-  typedef std::map<Long64_t, std::pair<Double_t, Double_t>> TFractionMap; //!
-  typedef std::map<Double_t, std::set<Double_t>> TBinMap; //!
+  typedef std::map<Long64_t, std::pair<Double_t, Double_t> > TFractionMap; //!
+  typedef std::map<Double_t, std::set<Double_t> > TBinMap; //!
 
   Candidate *fTower;
Index: modules/DenseTrackFilter.h
===================================================================
--- modules/DenseTrackFilter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/DenseTrackFilter.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -49,5 +49,5 @@
 
 private:
-  typedef std::map<Double_t, std::set<Double_t>> TBinMap; //!
+  typedef std::map<Double_t, std::set<Double_t> > TBinMap; //!
 
   Candidate *fBestTrack;
Index: modules/IdentificationMap.h
===================================================================
--- modules/IdentificationMap.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/IdentificationMap.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -46,5 +46,5 @@
 
 private:
-  typedef std::multimap<Int_t, std::pair<Int_t, DelphesFormula *>> TMisIDMap; //!
+  typedef std::multimap<Int_t, std::pair<Int_t, DelphesFormula *> > TMisIDMap; //!
 
   TMisIDMap fEfficiencyMap; //!
Index: modules/OldCalorimeter.h
===================================================================
--- modules/OldCalorimeter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/OldCalorimeter.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -36,6 +36,6 @@
 
 private:
-  typedef std::map<Long64_t, std::pair<Double_t, Double_t>> TFractionMap; //!
-  typedef std::map<Double_t, std::set<Double_t>> TBinMap; //!
+  typedef std::map<Long64_t, std::pair<Double_t, Double_t> > TFractionMap; //!
+  typedef std::map<Double_t, std::set<Double_t> > TBinMap; //!
 
   Candidate *fTower;
Index: modules/SimpleCalorimeter.h
===================================================================
--- modules/SimpleCalorimeter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/SimpleCalorimeter.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -52,5 +52,5 @@
 private:
   typedef std::map<Long64_t, Double_t> TFractionMap; //!
-  typedef std::map<Double_t, std::set<Double_t>> TBinMap; //!
+  typedef std::map<Double_t, std::set<Double_t> > TBinMap; //!
 
   Candidate *fTower;
Index: modules/TreeWriter.h
===================================================================
--- modules/TreeWriter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/TreeWriter.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -70,5 +70,5 @@
   typedef void (TreeWriter::*TProcessMethod)(ExRootTreeBranch *, TObjArray *); //!
 
-  typedef std::map<ExRootTreeBranch *, std::pair<TProcessMethod, TObjArray *>> TBranchMap; //!
+  typedef std::map<ExRootTreeBranch *, std::pair<TProcessMethod, TObjArray *> > TBranchMap; //!
 
   TBranchMap fBranchMap; //!
Index: modules/UniqueObjectFinder.cc
===================================================================
--- modules/UniqueObjectFinder.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/UniqueObjectFinder.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -92,5 +92,5 @@
 void UniqueObjectFinder::Finish()
 {
-  vector<pair<TIterator *, TObjArray *>>::iterator itInputMap;
+  vector<pair<TIterator *, TObjArray *> >::iterator itInputMap;
   TIterator *iterator;
 
@@ -108,5 +108,5 @@
 {
   Candidate *candidate;
-  vector<pair<TIterator *, TObjArray *>>::iterator itInputMap;
+  vector<pair<TIterator *, TObjArray *> >::iterator itInputMap;
   TIterator *iterator;
   TObjArray *array;
@@ -132,8 +132,8 @@
 //------------------------------------------------------------------------------
 
-Bool_t UniqueObjectFinder::Unique(Candidate *candidate, vector<pair<TIterator *, TObjArray *>>::iterator itInputMap)
+Bool_t UniqueObjectFinder::Unique(Candidate *candidate, vector<pair<TIterator *, TObjArray *> >::iterator itInputMap)
 {
   Candidate *previousCandidate;
-  vector<pair<TIterator *, TObjArray *>>::iterator previousItInputMap;
+  vector<pair<TIterator *, TObjArray *> >::iterator previousItInputMap;
   TObjArray *array;
 
Index: modules/UniqueObjectFinder.h
===================================================================
--- modules/UniqueObjectFinder.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/UniqueObjectFinder.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -50,7 +50,7 @@
   Bool_t fUseUniqueID;
 
-  Bool_t Unique(Candidate *candidate, std::vector<std::pair<TIterator *, TObjArray *>>::iterator itInputMap);
+  Bool_t Unique(Candidate *candidate, std::vector<std::pair<TIterator *, TObjArray *> >::iterator itInputMap);
 
-  std::vector<std::pair<TIterator *, TObjArray *>> fInputMap; //!
+  std::vector<std::pair<TIterator *, TObjArray *> > fInputMap; //!
 
   ClassDef(UniqueObjectFinder, 1)
Index: modules/VertexFinder.cc
===================================================================
--- modules/VertexFinder.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/VertexFinder.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -115,5 +115,5 @@
   // fewer than MinNDF tracks, release the tracks for other clusters to claim.
   sort(clusterSumPT2.begin(), clusterSumPT2.end(), secondDescending);
-  for(vector<pair<UInt_t, Double_t>>::const_iterator cluster = clusterSumPT2.begin(); cluster != clusterSumPT2.end(); cluster++)
+  for(vector<pair<UInt_t, Double_t> >::const_iterator cluster = clusterSumPT2.begin(); cluster != clusterSumPT2.end(); cluster++)
   {
     // Skip the cluster if it no longer has any tracks
@@ -130,5 +130,5 @@
     if((Int_t)clusterIDToInt.at(cluster->first).at("ndf") < fMinNDF)
     {
-      for(map<UInt_t, map<string, Int_t>>::iterator track = trackIDToInt.begin(); track != trackIDToInt.end(); track++)
+      for(map<UInt_t, map<string, Int_t> >::iterator track = trackIDToInt.begin(); track != trackIDToInt.end(); track++)
       {
         if(track->second.at("clusterIndex") != (Int_t)cluster->first)
@@ -155,5 +155,5 @@
   // descending sum(pt**2).
   clusterSumPT2.clear();
-  for(map<UInt_t, map<string, Int_t>>::const_iterator cluster = clusterIDToInt.begin(); cluster != clusterIDToInt.end(); cluster++)
+  for(map<UInt_t, map<string, Int_t> >::const_iterator cluster = clusterIDToInt.begin(); cluster != clusterIDToInt.end(); cluster++)
   {
 
@@ -164,5 +164,5 @@
   sort(clusterSumPT2.begin(), clusterSumPT2.end(), secondDescending);
 
-  for(vector<pair<UInt_t, Double_t>>::const_iterator cluster = clusterSumPT2.begin(); cluster != clusterSumPT2.end(); cluster++)
+  for(vector<pair<UInt_t, Double_t> >::const_iterator cluster = clusterSumPT2.begin(); cluster != clusterSumPT2.end(); cluster++)
   {
     DelphesFactory *factory = GetFactory();
@@ -213,5 +213,5 @@
   // trackPT vector.
   sort(trackPT.begin(), trackPT.end(), secondDescending);
-  for(vector<pair<UInt_t, Double_t>>::const_iterator track = trackPT.begin(); track != trackPT.end(); track++, maxSeeds++)
+  for(vector<pair<UInt_t, Double_t> >::const_iterator track = trackPT.begin(); track != trackPT.end(); track++, maxSeeds++)
   {
     if(track->second < fSeedMinPT)
@@ -228,5 +228,5 @@
 
   // Create the seeds from the SeedMinPT highest pt tracks.
-  for(vector<pair<UInt_t, Double_t>>::const_iterator track = trackPT.begin(); track != trackPT.end(); track++, clusterIndex++)
+  for(vector<pair<UInt_t, Double_t> >::const_iterator track = trackPT.begin(); track != trackPT.end(); track++, clusterIndex++)
   {
     addTrackToCluster(track->first, clusterIndex);
@@ -261,5 +261,5 @@
     {
 
-      for(map<UInt_t, map<string, Double_t>>::const_iterator track = trackIDToDouble.begin(); track != trackIDToDouble.end(); track++)
+      for(map<UInt_t, map<string, Double_t> >::const_iterator track = trackIDToDouble.begin(); track != trackIDToDouble.end(); track++)
       {
         if(trackIDToBool.at(track->first).at("claimed") || trackIDToInt.at(track->first).at("clusterIndex") == (Int_t)clusterIndex)
Index: modules/VertexFinder.h
===================================================================
--- modules/VertexFinder.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/VertexFinder.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -49,13 +49,13 @@
   TObjArray *fVertexOutputArray;
 
-  std::map<UInt_t, std::map<std::string, Double_t>> trackIDToDouble;
-  std::map<UInt_t, std::map<std::string, Int_t>> trackIDToInt;
-  std::map<UInt_t, std::map<std::string, Bool_t>> trackIDToBool;
+  std::map<UInt_t, std::map<std::string, Double_t> > trackIDToDouble;
+  std::map<UInt_t, std::map<std::string, Int_t> > trackIDToInt;
+  std::map<UInt_t, std::map<std::string, Bool_t> > trackIDToBool;
 
-  std::map<UInt_t, std::map<std::string, Double_t>> clusterIDToDouble;
-  std::map<UInt_t, std::map<std::string, Int_t>> clusterIDToInt;
-  std::map<UInt_t, std::map<std::string, Bool_t>> clusterIDToBool;
-  std::vector<std::pair<UInt_t, Double_t>> trackPT;
-  std::vector<std::pair<UInt_t, Double_t>> clusterSumPT2;
+  std::map<UInt_t, std::map<std::string, Double_t> > clusterIDToDouble;
+  std::map<UInt_t, std::map<std::string, Int_t> > clusterIDToInt;
+  std::map<UInt_t, std::map<std::string, Bool_t> > clusterIDToBool;
+  std::vector<std::pair<UInt_t, Double_t> > trackPT;
+  std::vector<std::pair<UInt_t, Double_t> > clusterSumPT2;
 
   ClassDef(VertexFinder, 1)
Index: modules/VertexFinderDA4D.cc
===================================================================
--- modules/VertexFinderDA4D.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/VertexFinderDA4D.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -1077,5 +1077,5 @@
   // avoid left-right biases by splitting highest Tc first
 
-  std::vector<std::pair<double, unsigned int>> critical;
+  std::vector<std::pair<double, unsigned int> > critical;
   for(unsigned int ik = 0; ik < y.size(); ik++)
   {
@@ -1085,5 +1085,5 @@
     }
   }
-  std::stable_sort(critical.begin(), critical.end(), std::greater<std::pair<double, unsigned int>>());
+  std::stable_sort(critical.begin(), critical.end(), std::greater<std::pair<double, unsigned int> >());
 
   for(unsigned int ic = 0; ic < critical.size(); ic++)
Index: modules/VertexSorter.cc
===================================================================
--- modules/VertexSorter.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ modules/VertexSorter.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -118,6 +118,6 @@
   map<Int_t, Double_t> clusterIDToSumPT2;
   map<Int_t, Double_t>::const_iterator itClusterIDToSumPT2;
-  vector<pair<Int_t, Double_t>> sortedClusterIDs;
-  vector<pair<Int_t, Double_t>>::const_iterator itSortedClusterIDs;
+  vector<pair<Int_t, Double_t> > sortedClusterIDs;
+  vector<pair<Int_t, Double_t> >::const_iterator itSortedClusterIDs;
 
   for(Int_t iCluster = 0; iCluster < fInputArray->GetEntries(); iCluster++)
Index: readers/DelphesCMSFWLite.cpp
===================================================================
--- readers/DelphesCMSFWLite.cpp	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
+++ readers/DelphesCMSFWLite.cpp	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
@@ -71,6 +71,6 @@
   fwlite::Handle<GenEventInfoProduct> handleGenEventInfo;
   fwlite::Handle<LHEEventProduct> handleLHEEvent;
-  fwlite::Handle<vector<reco::GenParticle>> handleParticle;
-  fwlite::Handle<vector<pat::PackedGenParticle>> handlePackedParticle;
+  fwlite::Handle<vector<reco::GenParticle> > handleParticle;
+  fwlite::Handle<vector<pat::PackedGenParticle> > handlePackedParticle;
 
   vector<reco::GenParticle>::const_iterator itParticle;